mod Ex07b logic: 'cl'

incl Mtex

incl Mauxb

loc rem 
  7. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 31.3.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [14:50,16:30,18:10]
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp
  konzultacie: stvrtok 13:00-14:00 miestnost I25

rem 
  

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane zoznamom 
  (triedenie, aplikacie). Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex07*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Section. Applications of Lists.  \end 

rem 
  \para \bf  Subsection. Finite Sets.  \end 

rem 
  \para \bf  Set membership.  \end 

pred/2 Inset 'Tex_p2_set_in'
  Inset(a,s) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_inset
    Set(s) -> Inset(a,s) <-> a in s
  \end

thm Spec_inset
  Set(s) -> Inset(a,s) <-> a in s

rem 
  \para \bf  Set insertion.  \end 

fun/2 Insert 'Tex_f2_set_insert'
  Insert(s,a) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_insert_in
    Set(s) -> b in Insert(s,a) <-> b = a \/ b in s
  \end
  \eq Spec_insert_set
    Set(s) -> Set Insert(s,a)
  \end

thm Spec_insert_in
  Set(s) -> b in Insert(s,a) <-> b = a \/ b in s

thm Spec_insert_set
  Set(s) -> Set Insert(s,a)

rem 
  \para \bf  Set deletion.  \end 

fun/2 Delete 'Tex_f2_set_delete'
  Delete(s,a) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_delete_in
    Set(s) -> b in Delete(s,a) <-> b in s & b != a
  \end
  \eq Spec_delete_set
    Set(s) -> Set Delete(s,a)
  \end

thm Spec_delete_in
  Set(s) -> b in Delete(s,a) <-> b in s & b != a

thm Spec_delete_set
  Set(s) -> Set Delete(s,a)

