mod Ex07c logic: 'cl'

incl Mtex

loc rem 
  7. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 31.3.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [14:50,16:30,18:10]
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp
  konzultacie: stvrtok 13:00-14:00 miestnost I25

rem 
  

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane zoznamom 
  (triedenie, aplikacie). Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex07*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Applications of Lists.  \end 

rem 
  \para \bf  Subsection. Polynomials.  \end 

rem 
  \para \bf  Denotation of polynomials.  \end 

fun/2 Denp 'Tex_f2_po_den'
  Denp(0,x) = 0
  Denp((a,p),x) = a+x*Denp(p,x)

rem 
  \para \bf  Addition of polynomials.  \end 

fun/2 Addp 'Tex_f2_po_add'
  Addp(p,q) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_addp_denp
    Denp(Addp(p,q),x) = Denp(p,x)+Denp(q,x)
  \end

thm Spec_addp_denp
  Denp(Addp(p,q),x) = Denp(p,x)+Denp(q,x)

rem 
  \para \bf  Multiplication of polynomials by constants.  \end 

fun/2 Multpc 'Tex_f2_po_multp'
  Multpc(a,p) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_multpc_denp
    Denp(Multpc(a,p),x) = a*Denp(p,x)
  \end

thm Spec_multpc_denp
  Denp(Multpc(a,p),x) = a*Denp(p,x)

rem 
  \para \bf  Multiplication of polynomials.  \end 

fun/2 Multp 'Tex_f2_po_mult'
  Multp(p,q) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_multp_denp
    Denp(Multp(p,q),x) = Denp(p,x)*Denp(q,x)
  \end

thm Spec_multp_denp
  Denp(Multp(p,q),x) = Denp(p,x)*Denp(q,x)

